/*
#define DEBUG
*	ivl
*
*	t@CXgo^Ǘ
*
*	from Jun.26,1999	by dummy.x.(with J-SAGA INDUSTRY)
*/
#include	<stddef.h>
#include	<string.h>
#include	"comtype.h"
#include	"easymac.h"
#include	"sysconst.h"
#include	"dummyc.h"
#include	"hufilec.h"
#include	"libpt4.h"
#include	"ivl.h"
#include	"mkpathfn.c"

/* 萔` */
#define	FILE_TBL_BLOCK	64		/* t@CǗe[ûPubNɊ܂܂t@C */

/* ϐ */
	/* \t@CǗ */
long arg_file_kaz;		/* Ǘt@C */
filelist_t *arg_file_tblp;	/* t@CǗe[uAhX */

/* t@Cϐ */
static long arg_file_tbl_max;		/* ݂̃e[uŊǗłt@C */
static char arg_file_tbl_alloc_failed;	/* e[ugstO(=!0:ɎsĂ) */


/* t@CǗe[ug
*	Ԓl:	gł΂̃e[uAhX
*		łȂꍇ NULL
*	L	* ֘Aet@Cϐ̒l𒼐ڏւB
*/
static
filelist_t *enhance_file_tbl(void)
{
	filelist_t *nptblp = arg_file_tblp;
	long curtblmax = arg_file_tbl_max;

	curtblmax += FILE_TBL_BLOCK;			/* o^ */
	nptblp = (filelist_t *)realloc(nptblp, (curtblmax * sizeof(filelist_t)));
							/* g */
	/* gɐt@Cϐւ */
	if (nptblp != NULL) {
		arg_file_tblp = nptblp;
		arg_file_tbl_max = curtblmax;
	}
	return nptblp;
}

/* DOS _FILES f[^mrāAt@C𒲂ׂ
*	:	files0p,files1p	- rΏۃf[^ւ̃|C^
*	Ԓl:	t@CȂ !0AĂ 0
*/
static
int is_same_filesbuf(const _filesbuf_t *files0p, const _filesbuf_t *files1p)
{
	int result;
#if	0
	if (chkbit(state_flag_bits. FBIT_FNCASE)) {	/* t@C̑召L */
		/* t@CȊO͂̂܂ܔrA
		*  t@C͕r('\0'ȍ~̃S~l)
		*/
		result = (memcmp(files0p, files1p, offsetof(_filesbuf_t, name)) == 0)
			&& (strcmp(files0p->name, files1p->name) == 0);
	} else {					/* t@C̑召͖ */
		/* t@CɊւ镔͕r(召)
		*  t@CȊO͂̂܂ܔr
		*/
		int i, j, k;

		i = offsetof(_filesbuf_t, filename);
		j = sizeof(files1p->filename) + sizeof(files1p->ext);
		k = offsetof(_filesbuf_t, name) - offsetof(_filesbuf_t, atr);
		result = (memcmp(files0p, filesc1p, i) == 0)
			&& (strnicmp(files0p->filename, files1p->filename, j) == 0)
			&& (memcmp(files0p->atr, files1p->atr, k) == 0)
			&& (strncmp(files0p->name, files1p->name) == 0);
	}
#else
	int i, j, k;

	i = offsetof(_filesbuf_t, filename);
	j = sizeof(files1p->filename) + sizeof(files1p->ext);
	k = offsetof(_filesbuf_t, name) - offsetof(_filesbuf_t, atr);
	result = (memcmp(files0p, files1p, i) == 0)
		&& (strnicmp(files0p->filename, files1p->filename, j) == 0)
		&& (memcmp(&(files0p->atr), &(files1p->atr), k) == 0)
		&& (stricmp(files0p->name, files1p->name) == 0);

#endif

	return result;
}

/* t@CɃXgɓo^Ă邩ׂ
*	:	entno	- Xgo^ԍ
*		filesp	- DOS _FILES obt@AhX
*	Ԓl:	o^Ă !0AȂ 0
*/
static
int is_entried_file(int entno, const _filesbuf_t *filesp)
{
	const filelist_t *flistp = arg_file_tblp + entno;

	while (--flistp >= arg_file_tblp) {
		if (is_same_filesbuf(filesp, &(flistp->fbuf))) {
			/* t@CI */
			return !0;
		}
	}
	/* Ǔt@C͂Ȃ */
	return 0;
}

/* t@CǗe[u֓o^
*	:	pathp	- t@C݃pXւ̃|C^
*		filesp	- DOS _FILES obt@AhX
*	Ԓl:	o^ԍ(0`)
*		^̗RŎsꍇ <0
*/
long entry_arg_file_name(const char *pathp, const _filesbuf_t *filesp)
{
	int entno = arg_file_kaz;
	char rdres;
	short wdots = -1, hdots = -1;
	pt4_struct_t *rdbufp;
	char *cp;
	filelist_t *flistp;

	/* e[ugɎsĂt@C̓o^͂Ȃ */
	if (arg_file_tbl_alloc_failed) {
		return -1;
	}

	/* pӂe[utɂȂĂg */
	if (entno >= arg_file_tbl_max) {
		if (enhance_file_tbl() == NULL) {	/* gs */
			ttlprintf("t@CǗe[ůgɎs܂B\n");
			ttlprintf("%s%s ȍ~Ɏw肳ꂽt@C͕\ł܂B\n"
				, pathp, filesp->name);
			arg_file_tbl_alloc_failed = !0;	/* stOZbg */
			return -1;
		}
	}

	/* pX */
	cp = strdup(pathp);
	if (cp == NULL) {	/* s */
		ttlprintf("t@C %s%s e[uo^łȂ߁A\ł܂B\n"
			, pathp, filesp->name);
		return -2;
	}

	/* t@Cɓo^ĂȂׂ */
	if (is_entried_file(entno, filesp)) {	/* t@CI */
_DEBUGJOB(ttlprintf("t@C %s%s ͊Ƀe[uo^ς݂łB\n", pathp, filesp->name));
		return -3;	/* o^ɕԂ */
	}

	/* t@CAhXe[uɓo^ */
	flistp = arg_file_tblp + entno;
	if (chkbit(state_flag_bits, FBIT_ONMEMORY)) {	/* sǂݍ݂ */
		rdres = read_pt4(&rdbufp, make_path_filename(cp, filesp));
		if (rdres == RDPT4_SUCCESS) {
			wdots = rdbufp->width;
			hdots = rdbufp->height;
/*		} else {
			wdots = hdots = -1;
*/		}
	} else if (chkbit(state_flag_bits, FBIT_ONMEM_SZ)) {	/* TCYsǂݍ */
		pt4_struct_t phed;

		rdres = read_pt4_head(&phed, make_path_filename(cp, filesp));
		if (rdres == RDPT4_SUCCESS) {
			rdres = RDPT4_READ_FAIL;	/* ǂݍݎsƂĂ */
			wdots = phed.width;
			hdots = phed.height;
/*		} else {
			wdots = hdots = -1;
*/		}
	} else {					/* sǂݍ݂Ȃ */
		rdres = RDPT4_READ_FAIL;
		rdbufp = NULL;
/*		wdots = hdots = -1;
*/	}
	flistp->rdresult = rdres;	/* ǂݍ݌ */
	flistp->pathp = cp;		/* pX */
	flistp->fbuf = *filesp;		/* DOS _FILES f[^ */
	flistp->rdbufp = rdbufp;	/* ǂݍ݃obt@AhX */
	flistp->wdots = wdots;		/*  */
	flistp->hdots = hdots;		/* c */

	arg_file_kaz++;		/* Ǘt@Cv */

	return entno;
}

