#	Makefile for 'ivl.x'.
#
#	by d'm.	from Jun. 5,1999.

TARGET	= ivl.x
OBJS	= ivl.o ivl_iv.o ivl_ftbl.o ivl_draw.o ivl_ctrl.o ivl_oi.o	\
		libpt4.a

CC	= gcc.x

#if	defined(DEBUG)
GCCOPT	= -DDEBUG -g -fno-inline-functions -fstack-check
#else	/* defined(DEBUG) */
GCCOPT	= -finline-functions -fstrength-reduce -fforce-mem -fforce-addr -D__IOCS_INLINE__ -D__DOS_INLINE__
#endif	/* defined(DEBUG) */

ULDIR	= .
USERLIB	= $(ULDIR)\\dummyc.a $(ULDIR)\\hufilec.a $(ULDIR)\\clinearg.o

CCOPT	= -O $(GCCOPT) -I$(ULDIR) -Wall

ARR	= harr

%.o:	%.c
	$(CC) -o$@ -c $(CCOPT) $<

%.s:	%.c
	$(CC) -o$@ -S $(CCOPT) $<

%.a:	%.ars
	$(ARR) $(CCOPT) -o$@ $<

$(TARGET):	$(OBJS)
	$(CC) -o$@ $(OBJS) $(USERLIB) -ldos -liocs -lmb

ivl.o:		ivl.c ivl.h
ivl_iv.o:	ivl_iv.c ivl.h
ivl_ftbl.o:	ivl_ftbl.c ivl.h
ivl_draw.o:	ivl_draw.c ivl.h
ivl_ctrl.o:	ivl_ctrl.c ivl.h
ivl_oi.o:	ivl_oi.c ivl.h

libpt4.a:	libpt4.ars libpt4.h

#
clean:
	ldel -y *.o
	ldel -y $(TARGET)

#[end of makefile.]
