#	Makefile for 'clinearg.o'.
#
#	by d'm.	from Mar.21,2000.

CC	= gcc.x

#if	defined(DEBUG)
GCCOPT	= -DDEBUG -g -fno-inline-functions -fstack-check 
#else	/* defined(DEBUG) */
GCCOPT	= -finline-functions -fstrength-reduce -fforce-mem -fforce-addr
#endif	/* defined(DEBUG) */

ULDIR	= .
USERLIB	= $(ULDIR)\\dummyc.a $(ULDIR)\\hufilec.a

CCOPT	= -O $(GCCOPT) -I$(ULDIR) -Wall

# make rule.
clinearg.o:	clinearg.c clinearg.h
	$(CC) -o$@ -c $(CCOPT) -UINDIRECT_ARG_ALLOCATE $<

clargmes.o:	clinearg.c clinearg.h
	$(CC) -o$@ -c $(CCOPT) -DINDIRECT_MES_PRINT -UINDIRECT_ARG_ALLOCATE $<

clinearg.x:	clinearg.c clinearg.h
	$(CC) -o$@ $(CCOPT) -DTEST_MAIN_DEFINE -UINDIRECT_ARG_ALLOCATE $< $(USERLIB)
#
#[end of makefile.]
